clang 8.0.0

Macros | Functions
gfniintrin.h File Reference
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros
#define | _mm_gf2p8affineinv_epi64_epi8(A, B, I)
#define | _mm_mask_gf2p8affineinv_epi64_epi8(S, U, A, B, I)
#define | _mm_maskz_gf2p8affineinv_epi64_epi8(U, A, B, I)
#define | _mm256_gf2p8affineinv_epi64_epi8(A, B, I)
#define | _mm256_mask_gf2p8affineinv_epi64_epi8(S, U, A, B, I)
#define | _mm256_maskz_gf2p8affineinv_epi64_epi8(U, A, B, I)
#define | _mm512_gf2p8affineinv_epi64_epi8(A, B, I)
#define | _mm512_mask_gf2p8affineinv_epi64_epi8(S, U, A, B, I)
#define | _mm512_maskz_gf2p8affineinv_epi64_epi8(U, A, B, I)
#define | _mm_gf2p8affine_epi64_epi8(A, B, I)
#define | _mm_mask_gf2p8affine_epi64_epi8(S, U, A, B, I)
#define | _mm_maskz_gf2p8affine_epi64_epi8(U, A, B, I)
#define | _mm256_gf2p8affine_epi64_epi8(A, B, I)
#define | _mm256_mask_gf2p8affine_epi64_epi8(S, U, A, B, I)
#define | _mm256_maskz_gf2p8affine_epi64_epi8(U, A, B, I)
#define | _mm512_gf2p8affine_epi64_epi8(A, B, I)
#define | _mm512_mask_gf2p8affine_epi64_epi8(S, U, A, B, I)
#define | _mm512_maskz_gf2p8affine_epi64_epi8(U, A, B, I)
#define | __DEFAULT_FN_ATTRS __attribute__((__always_inline__, __nodebug__, __target__("gfni"), __min_vector_width__(128)))
#define | __DEFAULT_FN_ATTRS_Y __attribute__((__always_inline__, __nodebug__, __target__("avx,gfni"), __min_vector_width__(256)))
#define | __DEFAULT_FN_ATTRS_Z __attribute__((__always_inline__, __nodebug__, __target__("avx512bw,gfni"), __min_vector_width__(512)))
#define | __DEFAULT_FN_ATTRS_VL128 __attribute__((__always_inline__, __nodebug__, __target__("avx512bw,avx512vl,gfni"), __min_vector_width__(128)))
#define | __DEFAULT_FN_ATTRS_VL256 __attribute__((__always_inline__, __nodebug__, __target__("avx512bw,avx512vl,gfni"), __min_vector_width__(256)))

## Functions
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_gf2p8mul_epi8 (__m128i __A, __m128i __B)
static __inline__ __m128i __DEFAULT_FN_ATTRS_VL128 | _mm_mask_gf2p8mul_epi8 (__m128i __S, __mmask16 __U, __m128i __A, __m128i __B)
static __inline__ __m128i __DEFAULT_FN_ATTRS_VL128 | _mm_maskz_gf2p8mul_epi8 (__mmask16 __U, __m128i __A, __m128i __B)
static __inline__ __m256i __DEFAULT_FN_ATTRS_Y | _mm256_gf2p8mul_epi8 (__m256i __A, __m256i __B)
static __inline__ __m256i __DEFAULT_FN_ATTRS_VL256 | _mm256_mask_gf2p8mul_epi8 (__m256i __S, __mmask32 __U, __m256i __A, __m256i __B)
static __inline__ __m256i __DEFAULT_FN_ATTRS_VL256 | _mm256_maskz_gf2p8mul_epi8 (__mmask32 __U, __m256i __A, __m256i __B)
static __inline__ __m512i __DEFAULT_FN_ATTRS_Z | _mm512_gf2p8mul_epi8 (__m512i __A, __m512i __B)
static __inline__ __m512i __DEFAULT_FN_ATTRS_Z | _mm512_mask_gf2p8mul_epi8 (__m512i __S, __mmask64 __U, __m512i __A, __m512i __B)
static __inline__ __m512i __DEFAULT_FN_ATTRS_Z | _mm512_maskz_gf2p8mul_epi8 (__mmask64 __U, __m512i __A, __m512i __B)

## Macro Definition Documentation

## ◆ __DEFAULT_FN_ATTRS

#define __DEFAULT_FN_ATTRS __attribute__((__always_inline__, __nodebug__, __target__("gfni"), __min_vector_width__(128)))

Definition at line 123 of file gfniintrin.h.

## ◆ __DEFAULT_FN_ATTRS_VL128

#define __DEFAULT_FN_ATTRS_VL128 __attribute__((__always_inline__, __nodebug__, __target__("avx512bw,avx512vl,gfni"), __min_vector_width__(128)))

Definition at line 132 of file gfniintrin.h.

Referenced by _mm_gf2p8mul_epi8(), and _mm_mask_gf2p8mul_epi8().

## ◆ __DEFAULT_FN_ATTRS_VL256

#define __DEFAULT_FN_ATTRS_VL256 __attribute__((__always_inline__, __nodebug__, __target__("avx512bw,avx512vl,gfni"), __min_vector_width__(256)))

Definition at line 133 of file gfniintrin.h.

Referenced by _mm256_gf2p8mul_epi8(), and _mm256_mask_gf2p8mul_epi8().

## ◆ __DEFAULT_FN_ATTRS_Y

#define __DEFAULT_FN_ATTRS_Y __attribute__((__always_inline__, __nodebug__, __target__("avx,gfni"), __min_vector_width__(256)))

Definition at line 126 of file gfniintrin.h.

Referenced by _mm_maskz_gf2p8mul_epi8().

## ◆ __DEFAULT_FN_ATTRS_Z

#define __DEFAULT_FN_ATTRS_Z __attribute__((__always_inline__, __nodebug__, __target__("avx512bw,gfni"), __min_vector_width__(512)))

Definition at line 129 of file gfniintrin.h.

Referenced by _mm256_maskz_gf2p8mul_epi8(), _mm512_gf2p8mul_epi8(), and _mm512_mask_gf2p8mul_epi8().

## ◆ _mm256_gf2p8affine_epi64_epi8

#define _mm256_gf2p8affine_epi64_epi8 | ( |  | A,
|  |  | B,
|  |  | I
| ) |  |

Value:
(__m256i)__builtin_ia32_vgf2p8affineqb_v32qi((__v32qi)(__m256i)(A), \
(__v32qi)(__m256i)(B), \
(char)(I))

Definition at line 93 of file gfniintrin.h.

## ◆ _mm256_gf2p8affineinv_epi64_epi8

#define _mm256_gf2p8affineinv_epi64_epi8 | ( |  | A,
|  |  | B,
|  |  | I
| ) |  |

Value:
(__m256i)__builtin_ia32_vgf2p8affineinvqb_v32qi((__v32qi)(__m256i)(A), \
(__v32qi)(__m256i)(B), \
(char)(I))

Definition at line 48 of file gfniintrin.h.

## ◆ _mm256_mask_gf2p8affine_epi64_epi8

#define _mm256_mask_gf2p8affine_epi64_epi8 | ( |  | S,
|  |  | U,
|  |  | A,
|  |  | B,
|  |  | I
| ) |  |

Value:
(__m256i)__builtin_ia32_selectb_256((__mmask32)(U), \
(__v32qi)_mm256_gf2p8affine_epi64_epi8(A, B, I), \
(__v32qi)(__m256i)(S))
__mmask32
unsigned int __mmask32
Definition: avx512bwintrin.h:31
_mm256_gf2p8affine_epi64_epi8
#define _mm256_gf2p8affine_epi64_epi8(A, B, I)
Definition: gfniintrin.h:93

Definition at line 98 of file gfniintrin.h.

## ◆ _mm256_mask_gf2p8affineinv_epi64_epi8

#define _mm256_mask_gf2p8affineinv_epi64_epi8 | ( |  | S,
|  |  | U,
|  |  | A,
|  |  | B,
|  |  | I
| ) |  |

Value:
(__m256i)__builtin_ia32_selectb_256((__mmask32)(U), \
(__v32qi)_mm256_gf2p8affineinv_epi64_epi8(A, B, I), \
(__v32qi)(__m256i)(S))
_mm256_gf2p8affineinv_epi64_epi8
#define _mm256_gf2p8affineinv_epi64_epi8(A, B, I)
Definition: gfniintrin.h:48
__mmask32
unsigned int __mmask32
Definition: avx512bwintrin.h:31

Definition at line 53 of file gfniintrin.h.

## ◆ _mm256_maskz_gf2p8affine_epi64_epi8

#define _mm256_maskz_gf2p8affine_epi64_epi8 | ( |  | U,
|  |  | A,
|  |  | B,
|  |  | I
| ) |  |

Value:
(__m256i)_mm256_mask_gf2p8affine_epi64_epi8((__m256i)_mm256_setzero_si256(), \
U, A, B, I)
_mm256_mask_gf2p8affine_epi64_epi8
#define _mm256_mask_gf2p8affine_epi64_epi8(S, U, A, B, I)
Definition: gfniintrin.h:98
_mm256_setzero_si256
static __inline __m256i __DEFAULT_FN_ATTRS _mm256_setzero_si256(void)
Constructs a 256-bit integer vector initialized to zero.
Definition: avxintrin.h:4291

Definition at line 103 of file gfniintrin.h.

## ◆ _mm256_maskz_gf2p8affineinv_epi64_epi8

#define _mm256_maskz_gf2p8affineinv_epi64_epi8 | ( |  | U,
|  |  | A,
|  |  | B,
|  |  | I
| ) |  |

Value:
(__m256i)_mm256_mask_gf2p8affineinv_epi64_epi8((__m256i)_mm256_setzero_si256(), \
U, A, B, I)
_mm256_mask_gf2p8affineinv_epi64_epi8
#define _mm256_mask_gf2p8affineinv_epi64_epi8(S, U, A, B, I)
Definition: gfniintrin.h:53
_mm256_setzero_si256
static __inline __m256i __DEFAULT_FN_ATTRS _mm256_setzero_si256(void)
Constructs a 256-bit integer vector initialized to zero.
Definition: avxintrin.h:4291

Definition at line 58 of file gfniintrin.h.

## ◆ _mm512_gf2p8affine_epi64_epi8

#define _mm512_gf2p8affine_epi64_epi8 | ( |  | A,
|  |  | B,
|  |  | I
| ) |  |

Value:
(__m512i)__builtin_ia32_vgf2p8affineqb_v64qi((__v64qi)(__m512i)(A), \
(__v64qi)(__m512i)(B), \
(char)(I))

Definition at line 108 of file gfniintrin.h.

## ◆ _mm512_gf2p8affineinv_epi64_epi8

#define _mm512_gf2p8affineinv_epi64_epi8 | ( |  | A,
|  |  | B,
|  |  | I
| ) |  |

Value:
(__m512i)__builtin_ia32_vgf2p8affineinvqb_v64qi((__v64qi)(__m512i)(A), \
(__v64qi)(__m512i)(B), \
(char)(I))

Definition at line 63 of file gfniintrin.h.

## ◆ _mm512_mask_gf2p8affine_epi64_epi8

#define _mm512_mask_gf2p8affine_epi64_epi8 | ( |  | S,
|  |  | U,
|  |  | A,
|  |  | B,
|  |  | I
| ) |  |

Value:
(__m512i)__builtin_ia32_selectb_512((__mmask64)(U), \
(__v64qi)_mm512_gf2p8affine_epi64_epi8(A, B, I), \
(__v64qi)(__m512i)(S))
_mm512_gf2p8affine_epi64_epi8
#define _mm512_gf2p8affine_epi64_epi8(A, B, I)
Definition: gfniintrin.h:108
__mmask64
unsigned long long __mmask64
Definition: avx512bwintrin.h:32

Definition at line 113 of file gfniintrin.h.

## ◆ _mm512_mask_gf2p8affineinv_epi64_epi8

#define _mm512_mask_gf2p8affineinv_epi64_epi8 | ( |  | S,
|  |  | U,
|  |  | A,
|  |  | B,
|  |  | I
| ) |  |

Value:
(__m512i)__builtin_ia32_selectb_512((__mmask64)(U), \
(__v64qi)_mm512_gf2p8affineinv_epi64_epi8(A, B, I), \
(__v64qi)(__m512i)(S))
__mmask64
unsigned long long __mmask64
Definition: avx512bwintrin.h:32
_mm512_gf2p8affineinv_epi64_epi8
#define _mm512_gf2p8affineinv_epi64_epi8(A, B, I)
Definition: gfniintrin.h:63

Definition at line 68 of file gfniintrin.h.

## ◆ _mm512_maskz_gf2p8affine_epi64_epi8

#define _mm512_maskz_gf2p8affine_epi64_epi8 | ( |  | U,
|  |  | A,
|  |  | B,
|  |  | I
| ) |  |

Value:
(__m512i)_mm512_mask_gf2p8affine_epi64_epi8((__m512i)_mm512_setzero_si512(), \
U, A, B, I)
_mm512_setzero_si512
static __inline __m512i __DEFAULT_FN_ATTRS512 _mm512_setzero_si512(void)
Definition: avx512fintrin.h:183
_mm512_mask_gf2p8affine_epi64_epi8
#define _mm512_mask_gf2p8affine_epi64_epi8(S, U, A, B, I)
Definition: gfniintrin.h:113

Definition at line 118 of file gfniintrin.h.

## ◆ _mm512_maskz_gf2p8affineinv_epi64_epi8

#define _mm512_maskz_gf2p8affineinv_epi64_epi8 | ( |  | U,
|  |  | A,
|  |  | B,
|  |  | I
| ) |  |

Value:
(__m512i)_mm512_mask_gf2p8affineinv_epi64_epi8((__m512i)_mm512_setzero_si512(), \
U, A, B, I)
_mm512_mask_gf2p8affineinv_epi64_epi8
#define _mm512_mask_gf2p8affineinv_epi64_epi8(S, U, A, B, I)
Definition: gfniintrin.h:68
_mm512_setzero_si512
static __inline __m512i __DEFAULT_FN_ATTRS512 _mm512_setzero_si512(void)
Definition: avx512fintrin.h:183

Definition at line 73 of file gfniintrin.h.

## ◆ _mm_gf2p8affine_epi64_epi8

#define _mm_gf2p8affine_epi64_epi8 | ( |  | A,
|  |  | B,
|  |  | I
| ) |  |

Value:
(__m128i)__builtin_ia32_vgf2p8affineqb_v16qi((__v16qi)(__m128i)(A), \
(__v16qi)(__m128i)(B), \
(char)(I))

Definition at line 77 of file gfniintrin.h.

## ◆ _mm_gf2p8affineinv_epi64_epi8

#define _mm_gf2p8affineinv_epi64_epi8 | ( |  | A,
|  |  | B,
|  |  | I
| ) |  |

Value:
(__m128i)__builtin_ia32_vgf2p8affineinvqb_v16qi((__v16qi)(__m128i)(A), \
(__v16qi)(__m128i)(B), \
(char)(I))

Definition at line 32 of file gfniintrin.h.

## ◆ _mm_mask_gf2p8affine_epi64_epi8

#define _mm_mask_gf2p8affine_epi64_epi8 | ( |  | S,
|  |  | U,
|  |  | A,
|  |  | B,
|  |  | I
| ) |  |

Value:
(__m128i)__builtin_ia32_selectb_128((__mmask16)(U), \
(__v16qi)_mm_gf2p8affine_epi64_epi8(A, B, I), \
(__v16qi)(__m128i)(S))
_mm_gf2p8affine_epi64_epi8
#define _mm_gf2p8affine_epi64_epi8(A, B, I)
Definition: gfniintrin.h:77
__mmask16
unsigned short __mmask16
Definition: avx512fintrin.h:48

Definition at line 82 of file gfniintrin.h.

## ◆ _mm_mask_gf2p8affineinv_epi64_epi8

#define _mm_mask_gf2p8affineinv_epi64_epi8 | ( |  | S,
|  |  | U,
|  |  | A,
|  |  | B,
|  |  | I
| ) |  |

Value:
(__m128i)__builtin_ia32_selectb_128((__mmask16)(U), \
(__v16qi)_mm_gf2p8affineinv_epi64_epi8(A, B, I), \
(__v16qi)(__m128i)(S))
_mm_gf2p8affineinv_epi64_epi8
#define _mm_gf2p8affineinv_epi64_epi8(A, B, I)
Definition: gfniintrin.h:32
__mmask16
unsigned short __mmask16
Definition: avx512fintrin.h:48

Definition at line 37 of file gfniintrin.h.

## ◆ _mm_maskz_gf2p8affine_epi64_epi8

#define _mm_maskz_gf2p8affine_epi64_epi8 | ( |  | U,
|  |  | A,
|  |  | B,
|  |  | I
| ) |  |

Value:
(__m128i)_mm_mask_gf2p8affine_epi64_epi8((__m128i)_mm_setzero_si128(), \
U, A, B, I)
_mm_setzero_si128
static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_setzero_si128(void)
Creates a 128-bit integer vector initialized to zero.
Definition: emmintrin.h:3996
_mm_mask_gf2p8affine_epi64_epi8
#define _mm_mask_gf2p8affine_epi64_epi8(S, U, A, B, I)
Definition: gfniintrin.h:82

Definition at line 88 of file gfniintrin.h.

## ◆ _mm_maskz_gf2p8affineinv_epi64_epi8

#define _mm_maskz_gf2p8affineinv_epi64_epi8 | ( |  | U,
|  |  | A,
|  |  | B,
|  |  | I
| ) |  |

Value:
(__m128i)_mm_mask_gf2p8affineinv_epi64_epi8((__m128i)_mm_setzero_si128(), \
U, A, B, I)
_mm_mask_gf2p8affineinv_epi64_epi8
#define _mm_mask_gf2p8affineinv_epi64_epi8(S, U, A, B, I)
Definition: gfniintrin.h:37
_mm_setzero_si128
static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_setzero_si128(void)
Creates a 128-bit integer vector initialized to zero.
Definition: emmintrin.h:3996

Definition at line 43 of file gfniintrin.h.

## Function Documentation

## ◆ _mm256_gf2p8mul_epi8()

static __inline__ __m256i __DEFAULT_FN_ATTRS_Y _mm256_gf2p8mul_epi8 | ( | __m256i | __A,
|  | __m256i | __B
| ) |  |
| static

Definition at line 158 of file gfniintrin.h.

References __DEFAULT_FN_ATTRS_VL256.

Referenced by _mm256_mask_gf2p8mul_epi8().

## ◆ _mm256_mask_gf2p8mul_epi8()

static __inline__ __m256i __DEFAULT_FN_ATTRS_VL256 _mm256_mask_gf2p8mul_epi8 | ( | __m256i | __S,
|  | __mmask32 | __U,
|  | __m256i | __A,
|  | __m256i | __B
| ) |  |
| static

Definition at line 165 of file gfniintrin.h.

References __DEFAULT_FN_ATTRS_VL256, and _mm256_gf2p8mul_epi8().

Referenced by _mm256_maskz_gf2p8mul_epi8().

## ◆ _mm256_maskz_gf2p8mul_epi8()

static __inline__ __m256i __DEFAULT_FN_ATTRS_VL256 _mm256_maskz_gf2p8mul_epi8 | ( | __mmask32 | __U,
|  | __m256i | __A,
|  | __m256i | __B
| ) |  |
| static

Definition at line 173 of file gfniintrin.h.

References __DEFAULT_FN_ATTRS_Z, _mm256_mask_gf2p8mul_epi8(), and _mm256_setzero_si256().

## ◆ _mm512_gf2p8mul_epi8()

static __inline__ __m512i __DEFAULT_FN_ATTRS_Z _mm512_gf2p8mul_epi8 | ( | __m512i | __A,
|  | __m512i | __B
| ) |  |
| static

Definition at line 180 of file gfniintrin.h.

References __DEFAULT_FN_ATTRS_Z.

Referenced by _mm512_mask_gf2p8mul_epi8().

## ◆ _mm512_mask_gf2p8mul_epi8()

static __inline__ __m512i __DEFAULT_FN_ATTRS_Z _mm512_mask_gf2p8mul_epi8 | ( | __m512i | __S,
|  | __mmask64 | __U,
|  | __m512i | __A,
|  | __m512i | __B
| ) |  |
| static

Definition at line 187 of file gfniintrin.h.

References __DEFAULT_FN_ATTRS_Z, and _mm512_gf2p8mul_epi8().

Referenced by _mm512_maskz_gf2p8mul_epi8().

## ◆ _mm512_maskz_gf2p8mul_epi8()

static __inline__ __m512i __DEFAULT_FN_ATTRS_Z _mm512_maskz_gf2p8mul_epi8 | ( | __mmask64 | __U,
|  | __m512i | __A,
|  | __m512i | __B
| ) |  |
| static

Definition at line 195 of file gfniintrin.h.

References _mm512_mask_gf2p8mul_epi8(), and _mm512_setzero_si512().

## ◆ _mm_gf2p8mul_epi8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_gf2p8mul_epi8 | ( | __m128i | __A,
|  | __m128i | __B
| ) |  |
| static

Definition at line 136 of file gfniintrin.h.

References __DEFAULT_FN_ATTRS_VL128.

Referenced by _mm_mask_gf2p8mul_epi8().

## ◆ _mm_mask_gf2p8mul_epi8()

static __inline__ __m128i __DEFAULT_FN_ATTRS_VL128 _mm_mask_gf2p8mul_epi8 | ( | __m128i | __S,
|  | __mmask16 | __U,
|  | __m128i | __A,
|  | __m128i | __B
| ) |  |
| static

Definition at line 143 of file gfniintrin.h.

References __DEFAULT_FN_ATTRS_VL128, and _mm_gf2p8mul_epi8().

Referenced by _mm_maskz_gf2p8mul_epi8().

## ◆ _mm_maskz_gf2p8mul_epi8()

static __inline__ __m128i __DEFAULT_FN_ATTRS_VL128 _mm_maskz_gf2p8mul_epi8 | ( | __mmask16 | __U,
|  | __m128i | __A,
|  | __m128i | __B
| ) |  |
| static

Definition at line 151 of file gfniintrin.h.

References __DEFAULT_FN_ATTRS_Y, _mm_mask_gf2p8mul_epi8(), and _mm_setzero_si128().